var path = require('path')
module.exports = {
  entry: {
    "angularjs-js-tree": path.resolve(__dirname, './src/ng-js-tree.js')
  },
  output: {
    path: path.resolve(__dirname, './dist'),
    filename: "[name].js",
    libraryTarget: 'umd'
  },
  externals: {
    jquery: "jquery",
    angular: "angular"
  },
  module: {
    rules: [{
      test: /\.jsx?$/,
      loader: 'babel-loader',
      exclude: /node_modules/
    }, {
      test: /\.(png|jpe?g|gif|svg)(\?.*)?$/,
      loader: 'url-loader',
      options: {
        limit: 10000,
        name: 'static/img/[name].[ext]'
      }
    }, {
      test: /\.(woff2?|eot|ttf|otf)(\?.*)?$/,
      loader: 'url-loader',
      options: {
        limit: 10000,
        name: 'static/fonts/[name].[ext]'
      }
    }, {
      test: /\.css$/,
      loader: 'style-loader!css-loader'
    }]
  }
}
